#include <windows.h>
#include <stdio.h>

#define VWIN32_DIOC_DOS_IOCTL 1
#define VWIN32_DIOC_DOS_INT25 2
#define VWIN32_DIOC_DOS_INT26 3
#define VWIN32_DIOC_DOS_INT13 4

typedef struct _DIOC_REGISTERS {
    DWORD reg_EBX;
    DWORD reg_EDX;
    DWORD reg_ECX;
    DWORD reg_EAX;
    DWORD reg_EDI;
    DWORD reg_ESI;
    DWORD reg_Flags;
} DIOC_REGISTERS, *PDIOC_REGISTERS;

HANDLE hDevice;

void openVWIN32(void)
{
	hDevice = CreateFile("\\\\.\\vwin32",
	    0, 0, NULL, 0, FILE_FLAG_DELETE_ON_CLOSE, NULL);
}

void closeVWIN32(void)
{
	CloseHandle(hDevice);
}

int readSec(int flop, int sec, char *buf)
{
	DIOC_REGISTERS reg;
	BOOL fResult;
	DWORD cb;

	hDevice = CreateFile("\\\\.\\vwin32",
	    0, 0, NULL, 0, FILE_FLAG_DELETE_ON_CLOSE, NULL);

	reg.reg_EAX = flop;
	reg.reg_EBX = (DWORD *)buf;
	reg.reg_ECX = 0x0001;
	reg.reg_EDX = sec;
	reg.reg_Flags = 0x0001;     /* assume error (carry flag is set)  */

	fResult = DeviceIoControl(hDevice, 
	    VWIN32_DIOC_DOS_INT25,
	    &reg, sizeof(reg), 
	    &reg, sizeof(reg), 
	    &cb, 0);

	if (!fResult || (reg.reg_Flags & 0x0001)) return -1;

	return 0;
}

int writeSec(int flop, int sec, char *buf)
{
	HANDLE hDevice;
	DIOC_REGISTERS reg;
	BOOL fResult;
	DWORD cb;

	reg.reg_EAX = flop;
	reg.reg_EBX = (DWORD *)buf;
	reg.reg_ECX = 0x0001;
	reg.reg_EDX = sec;
	reg.reg_Flags = 0x0001;     /* assume error (carry flag is set)  */

	fResult = DeviceIoControl(hDevice, 
	    VWIN32_DIOC_DOS_INT26,
	    &reg, sizeof(reg), 
	    &reg, sizeof(reg), 
	    &cb, 0);

	if (!fResult || (reg.reg_Flags & 0x0001)) return -1;

	return 0;
}
